/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2016 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.compositor;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.fortiss.af3.platform.compose.IPlatformHierarchicalCompositionRules;
import org.fortiss.af3.platform.compose.PlatformHierarchicalCompositionRulesBase;
import org.fortiss.af3.platform.model.IArchitectureDomain;
import org.fortiss.af3.platform.model.IPlatformDomain;
import org.fortiss.af3.platform.raspberry.model.IBoardDomain;
import org.fortiss.af3.platform.raspberry.model.IProcessorDomain;

/**
 * 
 * @author chaudhary
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating RED Hash:
 */
public class RaspberryPlatformHierarchicalCompositionRules extends
		PlatformHierarchicalCompositionRulesBase {

	/** Singleton pattern. */
	public static IPlatformHierarchicalCompositionRules INSTANCE =
			new RaspberryPlatformHierarchicalCompositionRules();

	/** {@inheritDoc} */
	@Override
	public EList<Class<? extends IArchitectureDomain>> getAdmissibleChildDomains(
			Class<? extends IArchitectureDomain> domain) {
		EList<Class<? extends IArchitectureDomain>> rval =
				new BasicEList<Class<? extends IArchitectureDomain>>();

		if(domain.equals(IPlatformDomain.class)) {
			rval.add(IBoardDomain.class);
		} else if(hasEqualLevel(domain, IPlatformDomain.class)) {
			rval.add(IPlatformDomain.class);
		} else if(hasEqualLevel(domain, IBoardDomain.class)) {
			rval.add(IProcessorDomain.class);
		}
		return rval;
	}

}
